=== 5.102.0 (2026-03-01)

* Make connection_validator and connection_expiration extensions correct handle sharded_timed_queue connection pool (jeremyevans) (#2354)

* Add connection_checkout_event_callback extension to assist in collecting telemetry information (jeremyevans)

=== 5.101.0 (2026-02-01)

* Add detect_unnecessary_association_options plugin to warn/raise for unnecessary association options (jeremyevans)

=== 5.100.0 (2026-01-01)

* Do not report associations with :is_used option as unused in the unused_associations plugin (jeremyevans)

* Make Postgres::PGRange#to_s an alias of #inspect, showing friendly output (jeremyevans)

* Add single_statement_dataset_destroy plugin, so that dataset.destroy uses a single DELETE statement (jeremyevans)

* Support :collate option in set_column_type (jeremyevans)

=== 5.99.0 (2025-12-01)

* Support passing a set as a Dataset#full_text_search terms argument on MSSQL, MySQL, and PostgreSQL (jeremyevans)

* Optimize Dataset#as_set calls to avoid queries in the subset_static_cache plugin (jeremyevans)

* Optimize Model.as_set calls to avoid queries in the static_cache plugin (jeremyevans)

* Support filtering by associations with sets in the pg_array_associations plugin (jeremyevans)

* Support sets in the to_dot extension (jeremyevans)

* Support splitting nil values from sets in the split_array_nil extension (jeremyevans)

* Support sets as input where arrays are accepted as input and order doesn't matter in the pg_hstore_ops/pg_json_ops extensions (jeremyevans)

* Auto parameterize IN/NOT IN with sets in the pg_auto_parameterize_in_array extension (jeremyevans)

* Auto parameterize IN/NOT IN with sets of integers in the pg_auto_parameterize extension (jeremyevans)

* Support sets in the eval_inspect extension (jeremyevans)

* Support sets of integers or strings for include validations in the constraint_validations extension (jeremyevans)

* Support filtering by associations using a set of associated objects (jeremyevans)

* Disallow typecasting sets to string (similar to how hash and array are disallowed) (jeremyevans)

* Deprecate the set_literalizer extension (jeremyevans)

* Support sets in dataset filters similar to arrays, using IN/NOT IN (jeremyevans)

* Add Dataset#as_set and Dataset#select_set, as Set will be a core class in Ruby 4 (jeremyevans)

* Add support for Database#add_index :only option on PostgreSQL 11+ (KirIgor) (#2343)

* Add support for Database#indexes :invalid option on PostgresSQL (KirIgor, jeremyevans) (#2343)

=== 5.98.0 (2025-11-01)

* Make insert_returning_select use RETURNING when using table_select plugin (jeremyevans) (#2339)

* Fix Database#listen in postgres adapter to ignore all notifications after UNLISTEN (jeremyevans)

* Make Model.any? forward to the dataset, to work better with the any_not_empty extension (jeremyevans) (#2337)

* Make the rcte_tree and split_values plugins work together (jeremyevans)

* Make split_values plugin work when eager loading using join tables (jeremyevans) (#2336)

* Add Model#remove_key! to remove a key from values (jeremyevans)

* Add pg_auto_parameterize_duplicate_query_detection extension for N+1 query detection (jeremyevans)

* Recognize sqlite:filename and amalgalite:filename connection URLs (jeremyevans) (#2334)

=== 5.97.0 (2025-10-01)

* Simplify Postgres::PGRange#inspect output (jeremyevans)

* Add deprecated_associations plugin, for warning/raising for deprecated association access (jeremyevans)

* Clear all cached schema information when using Database#drop_schema on PostgreSQL (jeremyevans)

* Add Database#rename_schema on PostgreSQL (jeremyevans)

=== 5.96.0 (2025-09-01)

* Support alter_table rename_constraint on PostgreSQL 9.2+ (jeremyevans) (#2274)

* Do not auto parameterize PostgreSQL range and multirange types containing expressions (jeremyevans)

* Support sort and reverse methods in pg_array_ops extension on PostgreSQL 18+ (jeremyevans)

* Support :in_arrays option for Postgres::JSON{,B}#strip_nulls in pg_json_ops extension on PostgreSQL 18+ (jeremyevans)

* Support VIRTUAL generated columns on PostgreSQL 18+ using :virtual option (jeremyevans)

=== 5.95.1 (2025-08-05)

* Fix regression in 5.95.0 where :deferred would be ignored for unique and primary key constraints on PostgreSQL (jeremyevans) (#2321)

=== 5.95.0 (2025-08-01)

* Support num_waiting for the timed_queue and sharded_timed_queue connection pools (jeremyevans)

* Add class_table_inheritance_constraint_validations plugin, supporting constraint validations for all of the model's tables (sterlzbd, jeremyevans) (#2316, #2319)

* Support :no_inherit option for CHECK constraints on PostgreSQL 9.2+ (jeremyevans)

* Support :no_inherit option for NOT NULL constraints on PostgreSQL 18+ (jeremyevans)

* Support not_null: {name: "constaint_name"} column option for naming NOT NULL constraints on PostgreSQL 18+ (jeremyevans)

* Support :period foreign_key option for PERIOD on PostgreSQL 18+ (jeremyevans)

* Support :include unique/primary_key/exclude option for INCLUDE on PostgreSQL 11+ (jeremyevans)

* Support :nulls_not_distinct unique option for NULLS NOT DISTINCT on PostgreSQL 15+ (jeremyevans)

* Support :without_overlaps primary_key and unique option for WITHOUT OVERLAPS on PostgreSQL 18+ (jeremyevans)

=== 5.94.0 (2025-07-01)

* Support ALTER TABLE ALTER CONSTRAINT on PostgreSQL using alter_table alter_constraint method (jeremyevans)

* Add Dataset#for_no_key_update and #for_key_share on PostgreSQL (jeremyevans)

* Cache Dataset#nolock on Microsoft SQL Server (jeremyevans)

* Cache Dataset#for_share on PostgreSQL and MySQL (jeremyevans)

* Include :validated and :enforced entries for Database#check_constraints on PostgreSQL (jeremyevans)

* Include :validated and :enforced entries for Database#{,reversed_}foreign_key_list on PostgreSQL (jeremyevans)

* Support :not_enforced check and foreign key constraint option for NOT ENFORCED on PostgreSQL 18+ (jeremyevans)

* Support :primary_key and :unique column options accepting hash value for constraint options (jeremyevans)

* Consider all unique constraints when marking columns as non-NULL on DB2 (jeremyevans)

* Numerous minor performance improvements, mostly from rubocop-performance (jeremyevans)

=== 5.93.0 (2025-06-01)

* Add support to Dataset#explain for all PostgreSQL EXPLAIN options (jeremyevans)

* Make Dataset#{explain,analyze} work with the pg_auto_parameterize extension (jeremyevans)

* Support multilevel qualified identifiers in Database#create_table (jeremyevans)

* Add Sequel::OLD and Sequel::NEW constants, for use in RETURNING statements on PostgreSQL 18+ (jeremyevans)

* Fix SQL::QualifiedIdentifier handling of SQL::Identifier wrapping LiteralString values (jeremyevans)

* Fix literalization of SQL::Identifier wrapping LiteralString values (jeremyevans)

* Add Dataset#prepare_sql_type for setting the SQL type to use for prepare/call (jeremyevans)

=== 5.92.0 (2025-05-01)

* Use a qualified primary key for Model.paged_each and for the paged_operations plugin when using joined datasets (jeremyevans, davekaro) (#2299, #2300)

* Add Model.qualified_primary_key for returning a qualified version of the model's primary key (jeremyevans)

* Support sql_literal_allow_caching? method on objects that respond to sql_literal_append/sql_literal (jeremyevans)

* Support set_column_not_null as a reversible migration method (jeremyevans)

=== 5.91.0 (2025-04-01)

* Recognize datetime(N) types as :datetime again (broke in 5.32) (jeremyevans) (#2293)

* Fix possible concurrency issue in eager loading due to Method#hash iterating over a hash that can be inserted into concurrently (jeremyevans) (#2292)

* Add pg_auto_validate_enums plugin for automatically validating enum values on PostgreSQL (jeremyevans)

* Make pg_auto_constraint_validations cache file creation deterministic by sorting subhashes (jeremyevans)

* Support treat_string_list_as_untyped_array Database option in pg_auto_parameterize_in_array extension (jeremyevans)

* Support allow_by_default option in forbid_lazy_load extension (brandur) (#2288)

=== 5.90.0 (2025-03-01)

* Avoid one query per enum when loading pg_enum extension when pg_array extension is already loaded (nick96) (#2278, #2279)

* Automatically load the sql_comments Database extension when loading the sql_comments model plugin (jeremyevans) (#2276)

* Support :pg_auto_parameterize_min_array_size Database option in pg_auto_parameterize_in_array extension to control minimum array size to handle (jeremyevans)

* Add pg_eager_any_typed_array plugin, automatically transform eager loads to use = ANY(array_expr::type[]) instead of IN (value_list) (jeremyevans)

* Support :eager_loading_predicate_transform association option (jeremyevans)

* Support explicitly specifying :use_placeholder_loader association option (jeremyevans)

* Make SQL::BooleanExpression.from_value_pairs handle Dataset::PlaceholderLiteralizer::Argument with existing transformer correctly (jeremyevans)

* Make connection_validator extension not swallow exceptions raised by Database#valid_connection? (jeremyevans)

* Do not call Model.name while holding a mutex when setting temporary names for anonymous modules (jeremyevans) (#2273)

=== 5.89.0 (2025-02-01)

* Make connection_validator extension handle case where Database#valid_connection? raises an exception (jeremyevans)

* Support :compare_connections_by_identity Database option to work around bugs in other libraries or the ruby implementation (jeremyevans) 

* Make mysql2 adapter handle invalid statement handles when closing prepared statements (jeremyevans)

* Add query_blocker extension, for blocking queries inside a block (jeremyevans)

* Support alter_table add_primary_key/add_unique_constraint :using_index option on PostgreSQL 9.1+ (jeremyevans)

* Add temporary names for internally defined anonymous classes and modules on Ruby 3.3+ (jeremyevans)

=== 5.88.0 (2025-01-01)

* Add subset_static_cache plugin for statically caching subsets of a model class (jeremyevans)

* Allow class-level dataset methods to be overridable and call super to get the default behavior (jeremyevans)

* Support column aliases with data types on PostgreSQL, useful for selecting from functions returning records (jeremyevans)

* Break ties in timestamp migrator version handling using lexicographic sort of rest of migration filename (jeremyevans)

* Fix strict_unused_block warnings when running specs on Ruby 3.4 (jeremyevans)

=== 5.87.0 (2024-12-01)

* Add pg_schema_caching extension, for reloading OIDs for custom types when loading cached schema (jeremyevans)

* Make Database#schema hashes include :comment field on MySQL and PostgreSQL (Bahanix) (#2248, #2249)

* Add inspect_pk plugin to make it easier to retrieve model instance based on inspect output (jeremyevans)

* Treat all Trilogy errors with error code 1205 as Sequel::DatabaseLockTimeout in the trilogy adapter (jeremyevans)

* Allow Data{base,set}#extension to not require files if the extension is already registered (jeremyevans) (#2246)

* Do not limit imports to 40 rows at a time if using pg_auto_parameterize extension with the no_auto_parameterize method (davekaro) (#2242)

=== 5.86.0 (2024-11-01)

* Support the :disable_dqs Database option in the sqlite adapter to disable treating double quoted values as strings (jeremyevans) (#2233)

* Have the subset_conditions plugin support where_all and where_any methods to combine existing subsets with AND or OR (jeremyevans)

* Have the subset_conditions plugin add *_conditions methods for exclude method calls in addition to where and subset (jeremyevans)

* Use Ruby module naming instead of Java package naming for access to Java libraries in the jdbc adapters (kalenp) (#2235, #2236) 

* Make schema_dumper extension format options similar to Hash#inspect on Ruby 3.4+ (jeremyevans)

* Avoid deprecation warnings on Ruby 3.4.0-preview2 (jeremyevans)

* Handle FROM tables that are SQL::DelayedEvaluation instances when trying to get primary key values after INSERT on PostgreSQL (tomasmiguez) (#2230, #2232)

=== 5.85.0 (2024-10-01)

* Support json_table on PostgreSQL 17+ in the pg_json_ops extension (jeremyevans)

* Make Dataset#get and #first without argument not create intermediate datasets if receiver uses raw SQL (jeremyevans)

* Add dataset_run extension, for building SQL using datasets, and running with Database#run (jeremyevans)

* Switch default connection pool to timed_queue on Ruby 3.2+ (jeremyevans)

=== 5.84.0 (2024-09-01)

* Support creating VIRTUAL tables on SQLite via the create_table :using option (jeremyevans)

* Support json_{exists,value,query} on PostgreSQL 17+ in the pg_json_ops extension (jeremyevans)

* Remove documentation from the gem to reduce gem size by 25% (jeremyevans)

=== 5.83.1 (2024-08-08)

* Restore unescaping of database file paths in the sqlite and amalgalite adapters (jeremyevans) (#2201)

=== 5.83.0 (2024-08-01)

* Make optimistic_locking plugin not keep lock column in changed_columns after updating instance (jeremyevans) (#2196)

* Have defaults_setter plugin pass model instance to default_values callable if it has arity 1 (pedrocarmona) (#2195)

* Support string_agg extension on SQLite 3.44+ (segiddins) (#2191)

* Support schema-qualified table names when using create_table :temp with a Sequel::SQL::QualifiedIdentifier (jeremyevans) (#2185)

* Support MERGE WHEN NOT MATCHED BY SOURCE on PostgreSQL 17+ (jeremyevans)

* Add stdio_logger extension for a minimal logger that Sequel::Database can use (jeremyevans)

* Simplify Database#inspect output to database_type, host, database, and user (jeremyevans)

=== 5.82.0 (2024-07-01)

* Limit tactically eager loading to objects that have the same association reflection (jeremyevans) (#2181)

* Fix race condition in threaded/sharded_threaded connection pools that could cause stalls (jeremyevans)

* Emulate dropping a unique column or a column that is part of an index on SQLite 3.35.0+ (jeremyevans) (#2176)

* Support MERGE RETURNING on PostgreSQL 17+ (jeremyevans)

* Remove use of logger library in bin/sequel (jeremyevans)

* Support :connect_opts_proc Database option for late binding options (jeremyevans) (#2164)

=== 5.81.0 (2024-06-01)

* Fix ignored block warnings in a couple plugin apply methods on Ruby 3.4 (jeremyevans)

* Skip Ruby internal caller locations when searching for caller locations in caller_logging and provenance extensions (jeremyevans) 

* Add temporarily_release_connection Database extension for multithreaded transactional testing (jeremyevans)

=== 5.80.0 (2024-05-01)

* Support Dataset#skip_locked on MariaDB 10.6+ (simi) (#2150)

* Avoid allocating datasets in cases where the returned dataset would be the same as the receiver (jeremyevans)

* Add provenance dataset extension, which includes comments in queries showing how and where the dataset was built (jeremyevans)

=== 5.79.0 (2024-04-01)

* Support create_or_replace_view with :materialized option on PostgreSQL (nashby) (#2144)

* Support :unlogged_tables_default Database option on Postgres for making created tables unlogged by default (jeremyevans) (#2134)

* Add Dataset#select_prepend for prepending to the current selected columns (jeremyevans) (#2139)

=== 5.78.0 (2024-03-01)

* Support SQLite 3.45+ jsonb functions in the sqlite_json_ops extension (jeremyevans) (#2133)

* Support compounds (e.g. UNION) in conjunction with Database#values on PostgreSQL (jeremyevans) (#2137)

* Support :use_advisory_lock option to Migrator.run to use advisory locks when running migrations (jeremyevans) (#2089)

* Support Database#with_advisory_lock on PostgreSQL, MySQL, and Microsoft SQL Server (jeremyevans) (#2089)

=== 5.77.0 (2024-02-01)

* Support create_table :without_rowid option on SQLite (loranger32) (#2126)

* Warn by default if trying to eager_graph/association_join an association that uses a block, when the block would be ignored (jeremyevans)

* Speed up validates_unique in validation_helpers plugin by using empty? instead of count == 0 (numbata) (#2122)

* Speed up regexp matches in sqlite adapter on Ruby 2.4+ (jeremyevans)

* Add sqlite adapter :regexp_function_cache option for specifying the cache object to use (paddor, jeremyevans) (#2116)

* Respect list plugin :top option when inserting the first row into the model's table (johanmagnusson) (#2115)

* Switch default connection pool to timed_queue on Ruby 3.4+ (jeremyevans)

* Support on_duplicate_columns={raise,warn} parameter in connection URL when using duplicate_columns_handler extension (jeremyevans)

* Add transaction_connection_validator extension for retrying transactions on new connection if there is a disconnect error when starting transaction (jeremyevans)

=== 5.76.0 (2024-01-01)

* Improve performance and flexibility of regexp matching in sqlite adapter (paddor) (#2108)

* Support SQL::Identifier for Database#tables :schema option values on PostgreSQL (jeremyevans)

* Support generating rcte queries using UNION or UNION ALL in the rcte plugin (jonathanfrias) (#2107)

* Make Database#table_exists? on PostgreSQL handle lock or statement timeout errors as evidence the table exists (jeremyevans) (#2106)

* Work around DateTime.jd fractional second bug on JRuby in named_timezones extension (jeremyevans)

* Support fractional times and timestamps on SQLAnywhere (jeremyevans)

* Make round_timestamps extension use Dataset#sqltime_precision for rounding Sequel::SQLTime values (jeremyevans)

* Remove special handling of %N modifier in Dataset#default_timestamp_format (jeremyevans)

* Add Dataset#default_time_format private method, for adapters to override for time (not timestamp) formatting (jeremyevans)

* Remove Dataset#format_timestamp_offset private method (jeremyevans)

* Remove special handling of %z modifier in Dataset#default_timestamp_format (jeremyevans)

* Add Dataset#literal_date_or_time, for simpler use by bound argument code (jeremyevans)

* Add auto_cast_date_and_time extension, for casting date and time values using SQL standard functions (jeremyevans)

=== 5.75.0 (2023-12-01)

* Make any_not_empty? extension support passing pattern argument to any? (jeremyevans) (#2100)

* Respect :skip_transaction option in PostgreSQL Dataset#paged_each (jeremyevans) (#2097)

* Add TimestampMigrator.run_single to run a single migration file up or down (opya, jeremyevans) (#2093)

* Support INSERT RETURNING on MariaDB 10.5+, and use it when saving new model objects (jeremyevans)

* Add Database#{defer,immediate}_constraints on PostgreSQL for changing handling of deferrable constraints in a transaction (jeremyevans)

=== 5.74.0 (2023-11-01)

* Make generated columns show up in Database#schema when using SQLite 3.37+ (jeremyevans) (#2087)

* Add revert method for Sequel.migration blocks, to revert changes inside the block on up, and apply the changes on down (jeremyevans)

* Re-add is_json and is_not_json methods to the pg_json_ops extension, as the support was re-added in PostgreSQL 16 (jeremyevans)

* Avoid infinite loop when handling exceptions with a cause loop in jdbc adapter (jeremyevans)

=== 5.73.0 (2023-10-01)

* Handle disconnect errors in ibmdb and jdbc/db2 adapters (jeremyevans) (#2083)

* Support skipping transactions in Dataset#{import,paged_each} using :skip_transaction option (jeremyevans)

* Add Database#transaction :skip_transaction option to skip creating a transaction or savepoint (jeremyevans)

* Stop using a transaction for a single query if calling Dataset#import with a dataset (jeremyevans)

* Add paged_operations plugin for paged deletes and updates and other custom operations (jeremyevans) (#2080)

* Support to_tsquery: :websearch option to Dataset#full_text_search on PostgreSQL 11+ (jeremyevans) (#2075)

* Add MassAssignmentRestriction#model and #column for getting the model instance and related column for mass assignment errors (artofhuman, jeremyevans) (#2079)

* Stop using base64 library in column_encryption plugin (jeremyevans)

=== 5.72.0 (2023-09-01)

* Sort caches before marshalling when using schema_caching, index_caching, static_cache_cache, and pg_auto_constraint_validations (jeremyevans)

* Change the defaults_setter plugin do a deep-copy of database default hash/array values and delegates (jeremyevans) (#2069)

* Add pg_auto_parameterize_in_array extension, for converting IN/NOT IN to = ANY or != ALL for more types (jeremyevans)

* Fix literalization of infinite and NaN float values in PostgreSQL array bound variables (jeremyevans)

=== 5.71.0 (2023-08-01)

* Support ILIKE ANY on PostgreSQL by not forcing the use of ESCAPE for ILIKE (gilesbowkett) (#2066)

* Add pg_xmin_optimistic_locking plugin for optimistic locking for all models without database changes (jeremyevans)

* Recognize the xid PostgreSQL type as an integer type in the jdbc/postgresql adapter (jeremyevans)

* Make set_column_allow_null method reversible in migrations (enescakir) (#2060)

=== 5.70.0 (2023-07-01)

* Make static_cache plugin better handle cases where forbid_lazy_load plugin is already loaded (jeremyevans)

* Fix ShardedThreadedConnectionPool#remove_server to disconnect all connections if removing multiple servers (jeremyevans)

* Support SEQUEL_DEFAULT_CONNECTION_POOL environment variable for choosing connection pool when :pool_class Database option is not set (jeremyevans)

* Add sharded_timed_queue connection pool (jeremyevans)

* Make connection_{validator,expiration} and async_thread_pool extensions work with timed_queue connection pool (jeremyevans)

* Make connection_{validator,expiration} extensions raise error when used with single threaded pools (HoneyryderChuck, jeremyevans) (#2049)

* Workaround possible resource starvation in threaded connection pool (ioquatix) (#2048)

=== 5.69.0 (2023-06-01)

* Avoid unsupported flag warning when using the mysql adapter with ruby-mysql 3+ (jeremyevans)

* Make mysql adapter work with ruby-mysql 4+ (jeremyevans)

* Add Model::DatasetModule#model accessor (davekaro) (#2040)

* Add trilogy adapter (jeremyevans)

=== 5.68.0 (2023-05-01)

* Add validation_helpers_generic_type_messages plugin for more useful type validation failure messages (jeremyevans) (#2028)

* Make constraint_validations plugin not validate missing columns that have a default value (jeremyevans) (#2023)

* Skip normal type name parsing for enum/array/composite/range/multirange types on PostgreSQL (jeremyevans) (#2019)

* Fix corner case where pg_extended_date_support did not work correctly when using the jdbc/postgresql adapter (jeremyevans)

* Include :min_value and :max_value schema entries for date/timestamp/timestamptz columns on PostgreSQL 9.6+ (jeremyevans)

=== 5.67.0 (2023-04-01)

* Fix dumping of string column sizes in the schema dumper on MSSQL (jeremyevans) (#2013)

* Improve dumping of tables in non-default schemas in the schema_dumper extension (jeremyevans) (#2006)

* Make Database#{tables,views} support :qualify option on Microsoft SQL Server (jeremyevans)

* Avoid use of singleton classes for datasets instances on Ruby 2.4+ (jeremyevans) (#2007)

* Deprecate registering datasets extensions using an object other than a module (jeremyevans)

* Add set_literalizer extension, for treating set usage in datasets similar to array usage (jeremyevans) (#1997)

=== 5.66.0 (2023-03-01)

* Recognize SQLite error related to strict tables as a constraint violation when using the amalgalite adapter (jeremyevans)

* Make Dataset#count work correctly for datasets using Dataset#values (jeremyevans) (#1992)

* Make Dataset#count with no argument/block handle dataset with custom SQL using ORDER BY on MSSQL (jeremyevans)

* Make Dataset#empty? correctly handle datasets with custom SQL or using Dataset#values where the first value is NULL (andy-k, jeremyevans) (#1990)

=== 5.65.0 (2023-02-01)

* Allow pg_auto_parameterize extension to use placeholder loaders (jeremyevans)

* Do not include :min_value and :max_value schema entries for decimal/numeric columns on MySQL versions not supporting check constraints (jeremyevans)

* Make Database#indexes return indexes for partitioned tables on PostgreSQL 11+ (jeremyevans)

=== 5.64.0 (2023-01-01)

* Make :db_type column schema entries on SQLAnywhere include precision/scale information (jeremyevans)

* Include :min_value and :max_value schema entries for decimal/numeric columns on most databases (rolftimmermans, jeremyevans) (#1975)

* Support :graph_use_association_block association option to make eager_graph use the association block (jeremyevans)

* Make many_through_many and many_through_one associations support eager_graph callbacks (jeremyevans)

=== 5.63.0 (2022-12-01)

* Make validates_associated plugin avoid database type errors for non-integer association keys (jeremyevans) (#1968)

* Make tactical_eager_loading plugin work better with table inheritance plugins (rolftimmermans, jeremyevans) (#1962)

* Add support for pool_class: :timed_queue on Ruby 3.2+, using a Queue for available connections (jeremyevans)

* Allow :pool_class Database option to be specified as a string to more easily choose a different pool type (jeremyevans)

* Use compare_by_identity hashes for Thread-keyed hashes in threaded connection pools (jeremyevans)

* Skip use of JRuby workaround on JRuby 9.3.9.0+ in named_timezones extension as JRuby fixed the related bug (jeremyevans)

=== 5.62.0 (2022-11-01)

* Add back the pg_auto_parameterize extension for automatically using bound variables when using postgres adapter with pg driver (jeremyevans)

* Add pg_extended_integer_support extension for customizing behavior when literalizing a Ruby integer outside PostgreSQL bigint range (jeremyevans)

* Raise Postgres::IntegerOutsideBigintRange if attempting to literalize a Ruby integer outside PostgreSQL bigint range (jeremyevans)

* Add primary_key_lookup_check_values plugin for typecasting and checking primary key values during lookup (jeremyevans)

* Setup validation of minimum and maximum values for integer columns in auto_validations (jeremyevans)

* Add validates_max_value and validates_min_value to validation_helpers (jeremyevans)

* Include :min_value and :max_value schema entries for integer columns on most databases (jeremyevans)

* Don't wrap multi-inserts in a transaction when it's not required (shannoncole, jeremyevans) (#1945)

* Update mock PostgreSQL adapter to default to PostgreSQL 15 instead of PostgreSQL 14 (jeremyevans)

* Support fractional seconds in the named_timezones extension (jeremyevans) (#1943)

* Cache reflection datasets in the postgres adapter to improve performance (jeremyevans)

* Handle BC dates and timestamps in bound variables when using the pg_extended_date_support extension (jeremyevans)

* Correctly format hstore[] types in bound variables on PostgreSQL (jeremyevans)

* Fix corner case in eager loading where window function eager limit strategy is used, but row number entry is not removed (jeremyevans)

* Support server/shard specific :after_connect and :connect_sqls Database options (jeremyevans) (#1935)

=== 5.61.0 (2022-10-01)

* Make Database#foreign_key_list on PostgreSQL return results for partitioned tables (jeremyevans)

* Add Database#check_string_typecast_bytesize for checking bytesize of strings before typecasting (jeremyevans)

* Treat negative hexidecimal strings similar to positive hexidecimal strings when typecasting to integer (jeremyevans)

* Remove is_json and is_not_json methods from the pg_json_ops extension, as the support was removed in PostgreSQL 15 beta 4 (jeremyevans)

* Fix handling of timestamps before the date of calendar reform when using pg_extended_date_support extension on Ruby 3.2 (jeremyevans)

=== 5.60.1 (2022-09-02)

* Revert conversion of respond_to? to defined?, as it breaks with unused refinements on Ruby 2 (jeremyevans) (#1919)

=== 5.60.0 (2022-09-01)

* Support arbitrary expressions for date_arithmetic interval values on PostgreSQL 9.4+ (jeremyevans)

* Support native IS DISTINCT FROM on SQLite 3.39+ instead of emulating support in the is_distinct_from extension (jeremyevans)

* Support HAVING without GROUP BY on SQLite 3.39+ (jeremyevans)

* Convert most respond_to? calls to equivalent defined? for better performance (jeremyevans)

=== 5.59.0 (2022-08-01)

* Set :allow_eager association option to false for instance specific associations without eager loaders (jeremyevans)

* Add require_valid_schema plugin for checking that model classes have schema parsed as expected (jeremyevans)

* Model classes created from aliased expressions and literal strings no longer use the simple table optimization (jeremyevans)

* Model code that does not swallow connection errors will now also not swallow disconnect errors (jeremyevans) (#1892)

* Add is_json and is_not_json methods to the pg_json_ops extension, for the PostgreSQL 15+ IS [NOT] JSON operator (jeremyevans)

* Support :security_invoker view option on PostgreSQL 15+, for views where access uses permissions of user instead of owner (jeremyevans)

* Support :nulls_distinct index option on PostgreSQL 15+, for NULLS [NOT] DISTINCT (jeremyevans)

* Support sequel-postgres-pr driver in the postgres adapter (jeremyevans)

=== 5.58.0 (2022-07-01)

* Support :disable_split_materialized Database option on MySQL to work around optimizer bug in MariaDB 10.5+ affecting association tests (jeremyevans)

* Add Dataset#merge* methods to support MERGE statement on PostgreSQL 15+, MSSQL, Oracle, DB2, H2, HSQLDB, and Derby (jeremyevans)

=== 5.57.0 (2022-06-01)

* Make Database#create_function on PostgreSQL accept :parallel option (bananarne) (#1870)

* Add support for :on_update_current_timestamp column option on MySQL (jeremyevans)

* Add is_distinct_from extension with support for the IS DISTINCT FROM operator (jeremyevans)

=== 5.56.0 (2022-05-01)

* Make alter_table add_column/add_foreign_key methods support :index option to create an index on the column (jeremyevans)

* Support creation of STRICT tables on SQLite 3.37.0+ via create_table :strict option (jeremyevans)

* Add sqlite_json_ops extension for DSL support for JSON functions and operators added in SQLite 3.38.0 (jeremyevans)

* Recognize "INTEGER" type same as "integer" type in the schema dumper, helpful on SQLite 3.37.0+ (jeremyevans)

=== 5.55.0 (2022-04-01)

* Support :setup_regexp_function Database option in the sqlite adapter to allow the use of regexps when querying (jeremyevans)

* Add auto_restrict_eager_graph plugin for automatically disallow eager_graph with associations needing but lacking graph options (jeremyevans)

* Fix placeholder literalizer optimization for dataset aggregate methods on a model dataset (belousovAV) (#1847, #1848)

=== 5.54.0 (2022-03-01)

* Add enum plugin for treating columns as enums in a model (jeremyevans) (#1839)

=== 5.53.0 (2022-02-01)

* Make Dataset#_sql_comment private when using the Database sql_comments extension (jeremyevans)

* Fix prepared statements in the mysql2 adapter to reuse native prepared statements (jeremyevans) (#1832)

* Support H2 version 2+ in the jdbc/h2 adapter (jeremyevans) (#1817)

* Work around active_support breaking subclasses plugin on Ruby <3.1 (jeremyevans) (#1816)

* Fix error handling if trying to setup column_encryption plugin without keys (jeremyevans) (#1815)

=== 5.52.0 (2022-01-01)

* Use Class#subclasses if available in the subclasses plugin, instead of a custom Model.subclasses accessor (jeremyevans)

* Add Model.descendants and .freeze_descendants to subclasses plugin (jeremyevans)

* Avoid use of deprecated Refinement#include on Ruby 3.1+ (jeremyevans)

* Add date_parse_input_handler extension for custom handling of input to date parsing methods (jeremyevans)

* Make postgres adapter respect Database#default_string_column_size (jeremyevans)

* Make pg_interval extension work with ActiveSupport 7.0 (jeremyevans)

* Make :ruby_default schema entry for type: :datetime respect Sequel.datetime_class (jeremyevans)

* Make alter_table drop_constraint have an effect on MySQL 8.0.19+ (jeremyevans)

* Make mysql adapter support ruby-mysql 3 API (jeremyevans) (#1795)

* Make mysql adapter no longer use connection's server_version, since it isn't accurate when using the ruby-mysql driver (jeremyevans)

* Add sql_comments plugin for automatically including comments on queries generated by model class, instance, and dataset methods (jeremyevans)

* Make sql_comments Database extension support Database#with_comments, for automatically including comments for queries executed inside the block (jeremyevans)

* Fix sql_comments extension to not modify cached SQL for a dataset (jeremyevans)

=== 5.51.0 (2021-12-01)

* Make eager loading via tactical_eager_loading no longer modify objects who already have a cached value for the association (jeremyevans)

* Make association cloning handle cases where clone association sets different :class option than cloned association (jeremyevans)

* Make column schema entries on MySQL include an :extra entry for the Extra column in DESCRIBE output (bschmeck) (#1791)

* Update mock PostgreSQL adapter to default to PostgreSQL 14 instead of PostgreSQL 9.5 (jeremyevans)

* Support Dataset#with_recursive :search and :cycle options on PostgreSQL 14+ for result ordering and cycle detection (jeremyevans)

* Avoid method redefined verbose mode warnings in lazy_attributes plugin (jeremyevans)

=== 5.50.0 (2021-11-01)

* Make Migrator :allow_missing_migration_files also allow down migrations where the current database version is greater than the last migration file version (francisconeves97) (#1789)

* Fix Model#freeze in composition, serialization, and serialization_modification_detection plugins to return self (jeremyevans) (#1788)

* Fix typecasting of lazy columns when using lazy_attributes plugin in model where dataset selects from subquery (jeremyevans)

* Add :before_preconnect Database option, for configuring extensions loaded via :preconnect_extensions (MarcPer, jeremyevans) (#1786)

* Change Dataset#columns! to use a LIMIT 0 query instead of a LIMIT 1 query (jeremyevans)

* Add sql_log_normalizer extension for normalizing logged SQL, helpful for analytics and sensitive data (jeremyevans)

* Add support for range_merge, multirange, and unnest, and PGMultiRange#op to pg_range_ops extension (jeremyevans)

* Add pg_multirange extension with support for PostgreSQL 14+ multirange types (jeremyevans)

=== 5.49.0 (2021-10-01)

* Switch block_given? usage to defined?(yield) (jeremyevans)

* Support table aliases for JOIN USING columns on PostgreSQL 14+ (jeremyevans)

* Support calling PostgreSQL procedures without arguments (jeremyevans)

* Support hstore subscripts in pg_hstore_ops on PostgreSQL 14+, for updating only part of an hstore value (jeremyevans)

* Support JSONB subscripts in pg_json_ops on PostgreSQL 14+, for updating only part of a JSONB value (jeremyevans)

* Support SQL::Expression#sequel_ast_transform for custom AST transforms on arbitrary expressions (jeremyevans)

* Add Database#create_trigger :replace option on PostgreSQL 14+ for CREATE OR REPLACE TRIGGER (jeremyevans)

* Make auto_validations plugin automatically setup no_null_byte validations (jeremyevans)

* Add Model#validates_no_null_byte to validation_helpers plugin (jeremyevans)

=== 5.48.0 (2021-09-01)

* Make the unused_associations plugin association reflection tracking work correctly when combining coverage runs (jeremyevans)

* Add Database#like_without_collate on MSSQL, to avoid using COLLATE on LIKE arguments, which can significantly improve performance (jeremyevans)

* Add Model::Errors#full_message private method for easiest i18n support for errors with multiple attributes (jeremyevans) (#1779)

=== 5.47.0 (2021-08-01)

* Make the unused_associations plugin track access to association reflections to determine whether associations are used (jeremyevans)

* Support :db option for join tables in {many,one}_through_many to use a separate query for each join table (jeremyevans)

* Support :join_table_db option for many_to_many/one_through_one associations, to use a separate query for the join table (jeremyevans)

* Support :allow_eager_graph and :allow_filtering_by association options (jeremyevans)

* Add Database#rename_tables on MySQL, for renaming multiple tables in a single call (nick96) (#1774)

* Support Dataset#returning on SQLite 3.35+ (jeremyevans)

=== 5.46.0 (2021-07-01)

* Add unused_associations plugin, for determining which associations and association methods are not used (jeremyevans)

* Make nil :setter/:adder/:remover/:clearer association options not create related methods (jeremyevans)

=== 5.45.0 (2021-06-01)

* Fix handling of NULL values in boolean columns in the ODBC adapter (jeremyevans) (#1765)

* Add auto_validations_constraint_validations_presence_message plugin for auto_validations/constraint_validations presence message integration (jeremyevans)

* Support Dataset#with :materialized option on SQLite 3.35+ for [NOT] MATERIALIZED (jeremyevans)

* Use ALTER TABLE DROP COLUMN for dropping columns on SQLite 3.35+ (jeremyevans)

=== 5.44.0 (2021-05-01)

* Add concurrent_eager_loading plugin, for eager loading multiple associations concurrently using separate threads (jeremyevans)

* Support :weeks as a interval unit in the date_arithmetic extension (jeremyevans) (#1759)

* Raise an exception if an interval hash with an unsupported key is passed in the date_arithmetic extension (jeremyevans) (#1759)

* Support dropping non-composite unique constraints on SQLite (jeremyevans) (#1755)

=== 5.43.0 (2021-04-01)

* Add column_encryption plugin, for encrypting column values (jeremyevans)

=== 5.42.0 (2021-03-01)

* Make the ado timestamp conversion proc a normal conversion proc that can be overridden similar to other conversion procs (jeremyevans)

* Add :reject_nil option to the nested_attributes method, to ignore calls where nil is passed as the associated object data (jeremyevans)

* Add async_thread_pool plugin for easier async usage with model classes and support for async destroy, with_pk, and with_pk! methods (jeremyevans)

* Add async_thread_pool Database extension for executing queries asynchronously using a thread pool (jeremyevans)

* Fix possible thread safety issue in Database#extension that could allow Module#extended to be called twice with the same Database instance (jeremyevans)

* Support cases where validations make modifications beyond setting errors in Model#freeze (jeremyevans)

* Add Model#to_json_data to the json_serializer plugin, returning a JSON data structure (jeremyevans)

=== 5.41.0 (2021-02-01)

* Have explicit :text option for a String column take priority over :size option on PostgreSQL (jeremyevans) (#1750)

* Support a :skip_invalid option in auto_validations plugin for not adding errors to a column that already has an error (jeremyevans)

* Support a :skip_invalid option in validation_helpers for not adding an error to a column that already has an error (jeremyevans)

* Support :adder, :remover, and :clearer association options that use keyword arguments in Ruby 2.7+ (jeremyevans)

* Make pg_interval use the same number of seconds per year and per month as ActiveSupport::Duration when using ActiveSupport 5.1+ (jeremyevans)

=== 5.40.0 (2021-01-01)

* Support UPDATE FROM syntax in SQLite 3.33.0+ (jeremyevans)

* Have pg_interval extension work with ActiveSupport 6.1 (jeremyevans)

* Have date_arithmetic extension work with ActiveSupport 6.1 (jeremyevans)

* Avoid method redefinition warnings in verbose warning mode (jeremyevans)

=== 5.39.0 (2020-12-01)

* Support :clustered option for primary key and unique constraints on Microsoft SQL Server (jeremyevans)

* Do not modify the size of binary columns when using set_column_allow_null on Microsoft SQL Server (jeremyevans) (#1736)

* Add a fork safety guide with more detail on how to use Sequel with libraries that fork (janko) (#1733)

* Make the roots_dataset method in the tree plugin work with queries using joins (jeremyevans) (#1731)

* Make Database#tables return partitioned tables on PostgreSQL 10+ (epoberezhny) (#1729, #1730)

=== 5.38.0 (2020-11-01)

* Do not add new Database instances to Sequel::DATABASES if the test connection fails (jeremyevans) (#1727)

* Support the newer com.mysql.cj.jdbc.Driver in the jdbc/mysql adapter (jeremyevans)

* Do not swallow disconnect errors in Database#create_or_replace_view or Database#create_table* on Oracle (jeremyevans)

* Only rescue non-disconnect Sequel::DatabaseErrors in Postgres::Database#server_version (jeremyevans) (#1724)

* Make the single_table_inheritance and prepared_statements plugins work if loaded into the same class (jeremyevans) (#1721)

=== 5.37.0 (2020-10-01)

* Recognize more unsigned decimal/float types in the schema dumper (akimd, jeremyevans) (#1720)

* Add Postgres::PGRow::{Array,Hash}Row#op to the pg_row_ops extension if the pg_row extension is loaded (jeremyevans)

* Add Model#column_previously_was and #column_previously_changed? to the dirty plugin (jeremyevans)

* Raise Migrator::Error if attempting to migrate down to a version where there are necessary migration files missing (jeremyevans) (#1716)

=== 5.36.0 (2020-09-01)

* Handle passing keyword arguments through class methods defined via Plugins.def_dataset_method on Ruby 2.7+ (jeremyevans)

* Handle passing keyword arguments through when loading plugins on Ruby 2.7+ (jeremyevans)

* Handle passing keyword arguments through migrations when defining custom Database methods that accept keywords on Ruby 2.7+ (jeremyevans)

* Handle passing keyword arguments through Dataset#query when using the query extension on Ruby 2.7+ (jeremyevans)

* Handle passing keyword arguments through the association proxy when using the association_proxies plugin on Ruby 2.7+ (jeremyevans)

* Handle passing keyword arguments through the class method to a method defined in dataset_module on Ruby 2.7+ (adam12) (#1713)

* Stream result sets in the odbc adapter for better performance and lower memory usage (sparrovv) (#1711)

* Add Postgres::JSONBOp#set_lax and #path_*_tz methods to the pg_json_ops extension for new jsonb functions added in PostgreSQL 13 (jeremyevans)

* Add Dataset#with_ties on PostgreSQL 13+ and Microsoft SQL Server to include rows with same order as final row (jeremyevans)

* Add a :current_schema option to Database#view_exists? (only defined on Oracle) to look in the current schema instead of non-system schemas (jeremyevans) (#1710)

* Recognize another disconnect error in the mysql and mysql2 adapters (jeremyevans) (#1706)

=== 5.35.0 (2020-08-01)

* Recognize another disconnect error in the oracle adapter (sterlzbd) (#1705)

* Consider all associations with :dataset options as instance-specific associations (jeremyevans)

* Make Model.finalize_associations not break with instance-specific associations (jeremyevans)

* Make association placeholder loader consider block if instance_specific: false association option is used (jeremyevans)

* Copy composite unique constraints when emulating alter table operations on SQLite (jeremyevans) (#1704)

* Add instance_specific_default plugin for setting default association :instance_specific value, or warning/raising for cases where it is not specified (jeremyevans)

* Make Model.plugin issue deprecation warning if loading plugin with arguments and block if plugin does not accept arguments/block (jeremyevans)

* Make validation_class_methods consider all :if, :allow_missing, :allow_nil, and :allow_blank settings, instead of just the first (jeremyevans)

* Include hash entries with nil keys in Dataset#to_dot output in to_dot extension (jeremyevans)

* Remove unneeded conditionals from plugins and extensions (jeremyevans)

* Fix exception class in run_transaction_hooks extension if calling run_after_{commit,rollback}_hooks outside of a transaction (jeremyevans)

=== 5.34.0 (2020-07-01)

* Make eager_graph work correctly if called with no associations (jeremyevans)

* Make :ruby eager limit strategy handle cases where there is no limit or offset (jeremyevans)

* Do not keep a reference to a Sequel::Database instance that raises an exception during initialization (jeremyevans)

* Make Database#pool.all_connections not yield for a single connection pool in disconnected state (jeremyevans)

* Raise an exception if trying to disconnect a server that doesn't exist in the sharded connection pools (jeremyevans)

* Support :refresh option when calling *_pks getter method in the association_pks plugin (jeremyevans)

* Support caching of repeated calls to *_pks getter method in the association_pks plugin using :cache_pks association option (jeremyevans)

* Add *_pks_dataset methods for one_to_many and many_to_many associations when using the association_pks plugin (jeremyevans)

=== 5.33.0 (2020-06-01)

* Support custom join types on a per-association basis when using eager_graph/association_join (jeremyevans)

* Support primary_key with type: :smallserial on PostgreSQL (j-a-m-l) (#1698)

* Add Database#current_timestamp_utc accessor on SQLite to keep CURRENT_* in UTC instead of converting to localtime (jeremyevans)

=== 5.32.0 (2020-05-01)

* Allow Database#create_table? work with :partition_of option on PostgreSQL (jeremyevans) (#1690)

* Add fiber_concurrency extension, for using Fiber.current instead of Thread.current for checking out connections (jeremyevans)

* Move most Sequel singleton methods into a module that extends Sequel for easier overriding (jeremyevans)

* Fix method visibility issues in model, plugin, extension, and adapter code (jeremyevans)

* Avoid defining conversion procs for PostgreSQL inet/cidr types in pg_inet extension when using sequel_pg 1.13.0+ (jeremyevans)

* Add run_transaction_hooks Database extension, allowing for running the transaction hooks before commit/rollback, for use with transactional testing (jeremyevans)

* Recognize timestamp(N) with time zone type (isc) (#1684)

=== 5.31.0 (2020-04-01)

* Fix alter_table drop_constraint :primary_key option on SQLite for non-integer primary keys (jeremyevans)

* Add skip_saving_columns plugin, which supports columns to skip when saving, and skips generated columns by default (joeosburn, jeremyevans) (#1681, #1682)

* Add support for creating partitioned tables in PostgreSQL 10+ using :partition_by and :partition_of options (jeremyevans)

* Dump generated columns as generated columns when using the schema_dumper with :same_db option on PostgreSQL 12+ (jeremyevans) (#1680)

* Ignore defaults for generated columns by default when using the schema dumper (jeremyevans) (#1680)

* Include generated columns in schema on SQLite 3.31+ (jeremyevans)

* Add :generated schema entry on PostgreSQL 12+ and SQLite 3.31+ for whether the columns is generated (jeremyevans)

* Add association_lazy_eager_option plugin for supporting :eager option for association method (jeremyevans)

* Add forbid_lazy_load plugin for forbidding lazy loading of associations, to help find N+1 issues (jeremyevans)

=== 5.30.0 (2020-03-01)

* Remove specs and old release notes from the gem to reduce gem size by over 40% (jeremyevans)

* When using Database#transaction :retry_on, call :before_retry option if retrying even if :num_retries is nil (jcmfernandes) (#1678)

* Support generated columns on SQLite 3.31+ using :generated_always_as and :generated_type options (jeremyevans)

=== 5.29.0 (2020-02-01)

* Recognize another disconnect error in the tinytds adapter (jeremyevans)

* Fix verbose warning in postgres adapter when using prepared statements and recent versions of ruby-pg (jeremyevans)

* Work correctly on Ruby 2.8+ by supporting second argument for initialize_clone (jeremyevans)

* Add empty_failure_backtraces plugin for empty backtraces for ValidationFailed and HookFailed exceptions, much faster on JRuby (jeremyevans)

* Add Dataset#json_serializer_opts to json_serializer plugin, allowing to set json_serializer options on a per-dataset basis (jeremyevans)

=== 5.28.0 (2020-01-01)

* Warn when calling Sequel::JDBC::Postgres::Dataset#with_fetch_size (jeremyevans) (#1665)

* Add exclude_or_null extension, for filtering datasets where the condition is false or NULL (jeremyevans)

* Add any_not_empty extension, for making Dataset#any? without a block mean !empty? (jeremyevans)

=== 5.27.0 (2019-12-01)

* Add Sequel::DEFAULT for a DEFAULT expression, useful for assigning to default values (jeremyevans)

* Make Postgres::ArrayOp#join in pg_array_ops extension work correctly on PostgreSQL <9.1 (jeremyevans)

* Make pg_enum extension work correctly on PostgreSQL 8.3-9.0 (jeremyevans)

* Emulate FILTER clause for aggregate functions using CASE on databases not supporting it directly (jeremyevans)

* Support ordering by NULLS FIRST/NULLS LAST without emulation on SQLite 3.30+ (jeremyevans)

=== 5.26.0 (2019-11-01)

* Recognize two additional foreign key constraint violation codes on MySQL 8.0.13+ (rianmcguire) (#1657)

* Support table aliases for single-table INSERT statements on PostgreSQL 9.5+ (jeremyevans) (#1656)

* Implement Sequel::Postgres::PGRange#hash so instances work correctly in hashes (jeremyevans) (#1648)

* Make dirty plugin work correctly with typecast_on_load plugin (jeremyevans) (#1647)

* Add support for :require_modification option when setting up nested_attributes (jeremyevans)

* Add support for SQL/JSON path expressions to the pg_json_ops extension, supported by PostgreSQL 12+ (jeremyevans)

=== 5.25.0 (2019-10-01)

* Fix Sequel::SQL::NumericMethods#coerce to not raise NoMethodError if super method is not defined (jeremyevans) (#1645)

* Allow setting a default for a column that already has a default on Microsoft SQL Server (jeremyevans)

* Fix keyword argument separation warnings on Ruby master branch in csv_serializer plugin (jeremyevans)

* Add association_multi_add_remove plugin for adding/removing multiple associated objects in a single method call (AlexWayfer, jeremyevans) (#1641, #1643)

* Make sharding plugin integrate with server_block extension (jeremyevans)

=== 5.24.0 (2019-09-01)

* Add Database#skip_logging? private method designed for extensions to force query timing even if no logger is present (adam12) (#1640)

* Allow a hostname specified in a defaults_file in the mysql2 adapter, by not explicitly setting :host (sapio-bdeamer) (#1638)

* Convert all database array types to Ruby arrays in the jdbc adapter (jeremyevans)

* Add static_cache_cache plugin for caching rows for static_cache models to a file to avoid database queries during model initialization (jeremyevans)

* Add :cache_file plugin option to pg_auto_constraint_validations plugin, for caching metadata to a file for faster initialization (jeremyevans)

* Support :unique_deferrable and :primary_key_deferrable column options (jeremyevans)

* Support :generated_always_as column option on PostgreSQL 12+ (jeremyevans)

=== 5.23.0 (2019-08-01)

* Work around a bug on jdbc-sqlite3 3.27.2.1 when parsing schema for tables with columns with default values (jeremyevans)

* Work around a bug in jdbc-sqlite3 3.27.2.1 when in Database#foreign_key_list in the jdbc/sqlite3 adapter (jeremyevans)

* Make Dataset#execute* private methods respect explicit servers option, fixing Dataset#paged_each in the postgres adapter when sharding (jeremyevans) (#1632)

* Handle instances of subclasses of core classes when wrapping objects in the pg_json extension (jeremyevans) (#1631)

* Support :ansi Database option in the tinytds adapter (kenaniah) (#1629)

* Support cross-database and linked servers when parsing schema on Microsoft SQL Server (kenaniah) (#1629)

* Add insert_conflict plugin for automatically handling unique constraint conflicts when saving new model instances on PostgreSQL 9.5+ and SQLite 3.24.0+ (jeremyevans)

* Avoid errors when parsing schema in the mock sqlite adapter (jeremyevans)

* Avoid possible thread-safety issue in the timezones support (jeremyevans)

* Handle offsets when typecasting an array or hash to datetime when Sequel.datetime_class = Time (jeremyevans)

* Support Sequel.datetime_class = Time when using the named_timezones extension (jeremyevans)

=== 5.22.0 (2019-07-01)

* Fix Dataset#multi_insert and #import with return: :primary_key on MSSQL when the dataset has a row_proc (jeremyevans) (#1627)

* Support Dataset#with :materialized option on PostgreSQL 12 for [NOT] MATERIALIZED (jeremyevans)

* Make Database#primary_key_sequence work on tables without serial sequences on PostgreSQL 12 (jeremyevans)

* Support ruby 2.7+ startless ranges in the pg_range extension (jeremyevans)

* Support ruby 2.7+ startless, endless ranges in filters, using an always true condition for them (jeremyevans)

* Support ruby 2.7+ startless ranges in filters, using just a <= or < operator for them (jeremyevans)

=== 5.21.0 (2019-06-01)

* Recognize additional DatabaseLockTimeout errors in mysql and mysql2 adapters (jeremyevans)

* Disallow eager_graph of ancestors and descendants associations when using the rcte_tree plugin (jeremyevans)

* Make jdbc/mysql adapter work when using JRuby with Java 11 (jeremyevans)

* Support window function options :window, :exclude, and :frame :type=>:groups, :start, and :end on SQLite 3.28.0+ (jeremyevans)

* Make the server_block extension respect the :servers_hash Database option (jeremyevans)

* Typecast string input for json/jsonb types as JSON strings instead of parsing as JSON in the pg_json extension when Database#typecast_json_strings is set to true (jeremyevans)

* Wrap JSON primitives (string, number, true, false, nil) in the pg_json extension when Database#wrap_json_primitives is set to true (jeremyevans)

* Convert the Database :timeout option to an integer in the sqlite adapter (jeremyevans) (#1620)

* Improve performance in ado adapter using more efficient inner loop (jeremyevans)

* Improve performance in ado adapter using faster callables for type conversion (jeremyevans)

* Fix handling of decimal values in the ado adapter when using locales where the decimal separator is , and not . (jeremyevans) (#1619)

=== 5.20.0 (2019-05-01)

* Fix reversing of alter_table add_foreign_key when :type option is used (jeremyevans) (#1615)

* Switch from using instance_exec to define_method for model associations and in some plugins (jeremyevans)

* Fix Database#server_version when using mysql2 adapter with mysql driver on MariaDB 10+ database (v-kolesnikov) (#1614)

* Make one_to_one setter method handle models that use joined datasets (jeremyevans) (#1612)

* Make auto_validations plugin work with the class_table_inheritance plugin (jeremyevans) (#1611)

* Avoid use of instance_exec for PlaceholderLiteralString#with_dataset (jeremyevans)

* Recognize float unsigned database types as float (keeguon, jeremyevans) (#1609)

* Support :savepoint options to Database#{after_commit,after_rollback} for making the hooks handle savepoints (jeremyevans)

* Avoid use of instance_exec in association_dependencies plugin (jeremyevans)

* Add pg_auto_constraint_validation_override to the pg_auto_constraint_validations plugin, for customizing columns and error message per constraint (jeremyevans)

* Make Database#check_constraints on PostgreSQL also include constraints where the related columns are not known (jeremyevans)

=== 5.19.0 (2019-04-02)

* Use more optimized approach to merging hashes in ruby 2.5+ (jeremyevans)

* Use SQLite extended result codes when using ruby-sqlite3 1.4.0+ (jeremyevans)

* Recognize additional SQLite extended result codes in the shared sqlite adapter (jeremyevans)

* Add Database#rename_enum_value to the pg_enum extension (AlexWayfer) (#1603)

* Make Database#drop_table delete constraint validations metadata for that table if using the constraint_validations extension (jeremyevans)

* Speed up row fetching in the sqlite adapter (jeremyevans)

* Speed up row fetching and type conversion in the sqlanywhere adapter (jeremyevans)

=== 5.18.0 (2019-03-01)

* Use singleton .call methods on plain objects instead of procs/methods for faster type conversion (jeremyevans)

* Add Sequel::SQL::Blob.call to avoid indirection when converting values from the database (jeremyevans)

* Use while instead of each for inner loops in sqlite and jdbc adapters for better performance (jeremyevans)

* Make after_initialize plugin not make the argument to Model.call optional (jeremyevans)

* Allow Dataset#paged_each to be called without a block in the postgres and mysql2 adapters (jeremyevans)

* Remove flow-control exceptions in connection_expiration and connection_validator extensions (jeremyevans)

* Add throw_failures plugin for throwing ValidationFailed and HookFailed exceptions instead of raising them, up to 10x performance increase on JRuby (jeremyevans)

* Support tzinfo 2 in addition to tzinfo 1 in the named_timezones extension (jeremyevans) (#1596)

=== 5.17.0 (2019-02-01)

* Support skip_auto_validations instance method in auto_validations plugin (oldgreen, jeremyevans) (#1592)

* Support :preconnect_extensions Database option for loading extensions before :preconnect option (jeremyevans)

* Avoid usage of Proc.new with implicit block as ruby 2.7+ deprecates this behavior (jeremyevans)

* Allow Sequel[].as to be used for constructing aliases with eager_graph (e.g. Model.eager_graph(Sequel[:a].as(:b))) (jeremyevans) (#1588)

=== 5.16.0 (2019-01-02)

* Convert integer columns to bigint columns when copying SQLite databases to other databases using bin/sequel -C (jeremyevans) (#1584)

* Use nicer error messages for missing or empty migration directories (Lavode) (#1585)

* Make alter table emulation work correctly in SQLite 3.26.0+ (jeremyevans) (#1582)

* Do not unset new one_to_one associated objects' reciprocal associations before saving associated objects in the nested_attributes plugin (jeremyevans)

* Do not validate new one_to_one associated objects twice when saving in the nested_attributes plugin (jeremyevans)

* Fix :qualify_tables option to class_table_inheritance plugin to work correctly with subclasses of subclasses (benalavi) (#1581)

* Make class_table_inheritance plugin use the schema cache instead of sending a query to get columns for tables (kenaniah) (#1580)

* Remove loading of mysqlplus in the mysql adapter (jeremyevans)

* Make mysql adapter work correctly on ruby 2.6+ (jeremyevans)

* Add Database#rollback_on_exit to rollback transactions instead of committing them when exiting the transaction block (jeremyevans)

* Enable window functions in SQLite 3.26.0+ (jeremyevans)

* Do not override existing methods when creating Sequel::Model attribute getter/setter methods (jeremyevans) (#1578)

* Use parentheses for expressions being subscripted (e.g. (array_agg(column))[1]) (jeremyevans)

=== 5.15.0 (2018-12-01)

* Add :conn_str option in the postgres adapter for PostgreSQL connection strings, if the pg driver is used (graywolf) (#1572)

* Add :qualify_tables option to class_table_inheritance plugin to automatically qualify subclass tables with superclass qualifier (benalavi) (#1571)

* Access already allocated connections in a thread safe manner when checking out connections in the sharded threaded connection pool (jeremyevans)

* Automatically support datasets using qualified tables in the class_table_inheritance plugin without having to use the :alias option (benalavi) (#1565)

* Support rename_column without emulation on SQLite 3.25+ (jeremyevans)

* Do not remove currently cached many_to_one associated objects when changing the related foreign key value from nil to non-nil (jeremyevans)

* Do not validate new *_to_many associated objects twice when saving in the nested_attributes plugin (jeremyevans)

* Add Model#skip_validation_on_next_save! for skipping validation on next save call (jeremyevans)

=== 5.14.0 (2018-11-01)

* Drop defaulting the :port option to 5432 in the postgres adapter, so that setting the :service option in :driver_options works (jeremyevans) (#1558)

* Do not cache values for columns without parseable defaults when using :cache option in defaults_setter plugin (jeremyevans)

* Emulate NULLS FIRST/LAST ordering on databases that do not natively support it (jeremyevans)

* Do not modify boolean expressions created from string or array if string or array is modified (jeremyevans)

* Make roots and roots_dataset dataset methods instead of class methods in the tree plugin (JelF) (#1554)

* Do not cache dataset SQL if dataset uses subquery that cannot cache SQL (jeremyevans)

* Make Model#=== work correctly for models with composite primary keys (jeremyevans)

* Add Model#pk_equal? as a more descriptive name for Model#=== (AlexWayfer) (#1550)

* Do not push down expression inversion in cases where it may result in incorrect behavior (e.g. ANY/SOME/ALL operators) (jeremyevans) (#1549)

=== 5.13.0 (2018-10-01)

* Support :single_value type in prepared statements (rintaun) (#1547)

* Make Model.all in static_cache plugin accept a block (AlexWayfer, jeremyevans) (#1543)

* Add constant_sql_override extension for overriding SQL used for constants such as CURRENT_TIMESTAMP (celsworth) (#1538)

* Do not cache from_self datasets if options are given (jeremyevans)

=== 5.12.0 (2018-08-31)

* Make constraint_validations extension respect Database#constraint_validations_table setting (jeremyevans)

* Make Sequel.extension load files from gems (jeremyevans)

* Map clob prepared statement argument type to OCI8::CLOB in the oracle adapter (pipistrellka) (#1534)

* Make Model.load_cache public in the static_cache plugin (AlexWayfer) (#1533)

* Enable support for NOWAIT on MariaDB 10.3+ (jeremyevans)

* Enable support for INTERSECT and EXCEPT on MariaDB 10.3+ (jeremyevans)

* Make tactical_eager_loading plugin handle automatic eager loading for associated objects created by eager_graph (jeremyevans)

* Cache eager_graph loader to speed up subsequent loads from the same dataset (jeremyevans)

* Add caller_logging database extension to log callers before queries, useful during development (jeremyevans)

* Add Database#call_procedure in the postgres adapter for calling PostgreSQL 11+ procedures (jeremyevans)

* Add eager_graph_eager plugin for chaining eager association loads after eager_graph association loads (jeremyevans)

* Support using Dataset#eager_graph in eager load callback for associations using join tables (jeremyevans)

* Make Dataset#graph handle existing selections without determinable aliases by forcing a subselect (jeremyevans)

* Freeze prepared statement arguments before returning the prepared statement (jeremyevans)

* Refactor emulated prepared statement internals to use a placeholder literalizer (jeremyevans)

=== 5.11.0 (2018-08-01)

* Fix using the jdbc/sqlserver adapter on JRuby 9.2+ (jeremyevans)

* Fix dumping schema for numeric/decimal columns with default values, broken starting in 5.9.0 (jeremyevans)

* Recognize additional check constraint violations on certain versions of SQLite (jeremyevans)

* Use cached model instances for Model.first calls without an argument or with a single integer argument in the static_cache plugin (AlexWayfer) (#1529)

* Support ON CONFLICT clause for INSERT on SQLite 3.24+ (jeremyevans)

* Support Dataset#window for WINDOW clause on MySQL 8 and SQLAnywhere (jeremyevans)

* Enable window function support on SQLAnywhere (jeremyevans)

* Support using a hash as a window function :frame option value, with support for ROWS/RANGE/GROUPS, numeric offsets, and EXCLUDE (jeremyevans)

* Allow using set_column_default with a nil value to remove the default value for a column on MySQL when the column is NOT NULL (jeremyevans)

=== 5.10.0 (2018-07-01)

* Use input type casts when using the postgres adapter with pg 0.18+ to reduce string allocations for some primitive types used as prepared statement arguments (jeremyevans)

* Assume local time if database timezone not specified when handling BC timestamps on JRuby 9.2.0.0 in the pg_extended_date_support extension (jeremyevans)

* Fix parsing of timetz types in the jdbc/postgresql adapter (jeremyevans)

* Make SQLTime.parse respect SQLTime.date and Sequel.application_timezone (jeremyevans)

* Add :top as an option in the list plugin (celsworth) (#1526)

* Fix Model#{ancestors,descendants,self_and_siblings} in the tree plugin when custom parent/children association names are used (jeremyevans) (#1525)

* Treat read-only mode error as disconnect error on mysql and mysql2 adapters, for better behavior on AWS Aurora cluster (jeremyevans)

* Don't use cached placeholder literalizers for in Dataset#{first,where_all,where_each,where_single_value} if argument is empty array or hash (jeremyevans)

* Support :tablespace option when adding tables, indexes, and materialized views on PostgreSQL (jeremyevans)

* Support :include option for indexes on PostgreSQL 11+ (jeremyevans)

* Allow the use of IN/NOT IN operators with set returning functions for Sequel::Model datasets (jeremyevans)

* Make many_to_pg_array associations in the pg_array_associations plugin work on PostgreSQL 11 (jeremyevans)

* Only load strscan library in pg_array extension if it is needed (jeremyevans)

* Don't remove related many_to_one associations from cache when setting column value to existing value for model instances that have not been persisted (jeremyevans) (#1521)

* Support ruby 2.6+ endless ranges in the pg_range extension (jeremyevans)

* Support ruby 2.6+ endless ranges in filters, using just a >= operator for them (jeremyevans)

=== 5.9.0 (2018-06-01)

* Support generated columns on MySQL 5.7+ and MariaDB 5.2+ (wjordan, jeremyevans) (#1517)

* Add escaped_like extension for creation of LIKE expressions with placeholders in the pattern without access to a dataset (jeremyevans)

* Modify jdbc adapter exception handling to work around ::NativeException deprecation in JRuby 9.2 (jeremyevans)

* Work around broken BC date handling in JRuby 9.2.0.0 (jeremyevans)

* Switch use of BigDecimal.new() to BigDecimal(), since the former is deprecated (jeremyevans)

* Add Sequel::VERSION_NUMBER for easier version comparisons (jeremyevans)

* Add Model.has_dataset? to determine if the model class has a dataset (AlexWayfer) (#1508)

* Support use of LIKE with ANY function on PostgreSQL by avoiding unnecessary use of ESCAPE syntax (jeremyevans)

* Disconnect connections left allocated by dead threads instead of returning the connections to the pool (jeremyevans)

* Make both threaded connection pools avoid disconnecting connections while holding the connection pool mutex (jeremyevans)

* Don't deadlock when disconnecting connections in the sharded_threaded connection pool when using connection_validator or connection_expiration extensions (jeremyevans)

* Don't modify hash argument passed in Model.nested_attributes in the nested_attributes plugin (jeremyevans)

* Avoid unnecessary hash creation in many places (jeremyevans)

* Fix duplicate objects in nested associations when eager_graphing cascaded many_to_one=>one_to_many associations (jeremyevans)

=== 5.8.0 (2018-05-01)

* Don't mark SQLAnywhere as supporting WITH in INSERT statement (jeremyevans)

* Support :search_path as a shard option on PostgreSQL (jeremyevans)

* Add Dataset#nowait for raising a Sequel::DatabaseLockTimeout when a locked row is encountered, supported on PostgreSQL, MySQL 8+, MSSQL, and Oracle (jeremyevans)

* Support Dataset#skip_locked on MySQL 8+ (jeremyevans)

* Make schema modification methods in the pg_enum extension work on a frozen Database object (jeremyevans)

* Support common table expressions and window functions on MySQL 8+ (jeremyevans)

* Ignore Dataset#explain :extended option on MySQL 5.7+, since extended output is then the MySQL default (jeremyevans)

* Work around REGEXP BINARY not working correctly on MySQL 8+ by using REGEXP_LIKE with the 'c' match_type (jeremyevans)

* Force correct column order in Database#foreign_key_list on MySQL (jeremyevans)

* Add ConnectionPool#connection_expiration_random_delay to connection_expiration extension, to avoid thundering herd if preallocating connections (hex2a, jeremyevans) (#1503)

* Emit deprecation warning in association_proxies plugin if using #filter on an association proxy, since behavior will change on ruby 2.6+ (utilum) (#1497)

* Handle multiple add_constraint calls and a set_column_null call in the same alter_table block on SQLite (jeremyevans) (#1498)

* Add Database#rename_enum to the pg_enum extension (AlexWayfer) (#1495)

* Make tactical_eager_loading plugin respect the :allow_eager association option (jeremyevans) (#1494)

* Add pg_auto_constraint_validations plugin, for automatically converting constraint violations to validation failures on PostgreSQL (jeremyevans)

* Don't make Model#_valid? public in the error_splitter plugin (jeremyevans)

* Support Database#indexes :include_partial option on PostgreSQL for including partial indexes (jeremyevans)

* Include more diagnostic information in Database#error_info on PostgreSQL (jeremyevans)

* Support Database#foreign_key_list :reverse option on PostgreSQL for parsing foreign key constraints that reference a given table (jeremyevans)

* Add Database#check_constraints on PostgreSQL for parsing CHECK constraints (jeremyevans)

* Don't use identity columns if :serial=>true or :type=>:serial|:bigserial column options are used (#1490) (jeremyevans)

* Cache Dataset#select_all datasets if no arguments are given (jeremyevans)

* Cache Dataset#returning datasets if no arguments are given (jeremyevans)

* Cache Dataset#qualify datasets if no argument is given (jeremyevans)

* Cache Dataset#lateral datasets (jeremyevans)

* Cache Dataset#from_self datasets if no options are given (jeremyevans)

* Cache Dataset#distinct datasets if no arguments or block is given (jeremyevans)

=== 5.7.0 (2018-04-01)

* Add Sequel.start_timer and .elapsed_seconds_since for more accurate elapsed time calculations on ruby 2.1+ (jeremyevans)

* Run Dataset#with_sql_{all,each,first,single_value} using a cached dataset to avoid clobbering the dataset's columns (jeremyevans)

* Add Database#convert_serial_to_identity on PostgreSQL 10.2+, which requires superuser access (jeremyevans)

* Fix Database#server_version when connecting to PostgreSQL 10.1+ in certain cases (jeremyevans)

* Free temporary clobs in the jdbc/oracle adapter to prevent a memory leak (jeremyevans) (#1482)

* Treat prepared statement errors due to changing types as disconnect errors in the postgres adapter (jeremyevans) (#1481)

* Add integer64 extension for treating Integer as a 64-bit integer when used as a generic type (jeremyevans)

* Allow many_to_pg_array remove_all_* method cast appropriately to work correctly for non-integer types (jeremyevans)

* Fix array_type for pg_array_to_many and many_to_pg_array associations in pg_array_associations plugin (jeremyevans)

* Use identity columns instead of serial columns for primary keys on PostgreSQL 10.2+ (jeremyevans)

* Support :identity option when creating columns on PostgreSQL 10+ to create identity columns (jeremyevans)

* Add Dataset#overriding_{system,user}_value on PostgreSQL for use with PostgreSQL 10+ identity columns (jeremyevans)

* Set :auto_increment schema entry correctly for PostgreSQL 10+ identity columns (jeremyevans)

=== 5.6.0 (2018-03-01)

* Dedup :db_type strings in schema hashes on Ruby 2.5+ (jeremyevans)

* Make schema_caching extension work with :callable_default schema values (jeremyevans)

* Freeze string valuse in hashes returned by Database#schema when using the schema_caching extension (jeremyevans)

* Protect migration file loading with a mutex to not break when multiple threads load migration files simultaneously (jeremyevans)

* Respect identifier mangling rules when renaming columns on Microsoft SQL Server (jeremyevans)

=== 5.5.0 (2018-01-31)

* Make Database#copy_table in the postgres adapter handle errors that occur while processing rows (jeremyevans) (#1470)

* Cache results of changed_columns method in local variables in many places for better performance (jeremyevans)

* Make modification_detection plugin not break column change detection for new objects (jeremyevans) (#1468)

* Make pg_range extension set :ruby_default schema value for recognized range defaults (jeremyevans)

* Make pg_interval extension set :ruby_default schema value for recognized interval defaults (jeremyevans)

* Make pg_json extension set :callable_default schema value for empty json/jsonb array/hash defaults (jeremyevans)

* Make pg_inet extension set :ruby_default schema value for recognized inet/cidr defaults (jeremyevans)

* Make pg_hstore extension set :callable_default schema value for empty hstore defaults (jeremyevans)

* Make pg_array extension set :callable_default schema value for recognized empty array defaults (jeremyevans) (#1466)

* Make defaults_setter plugin prefer :callable_default db_schema values over :ruby_default db_schema values (jeremyevans)

* Add defaults_setter plugin :cache option for caching default values returned (jeremyevans)

* Freeze string values in hashes returned by Database#schema (jeremyevans)

=== 5.4.0 (2018-01-04)

* Enable fractional seconds in timestamps on DB2 (jeremyevans) (#1463)

* Don't attempt to insert a second time if insert_select runs a query that doesn't return results, which can happen when triggers are used (jeremyevans)

* Make Dataset#insert_select on PostgreSQL and MSSQL return false instead of nil if the INSERT query is sent to the database but returns no rows (jeremyevans)

* Add index_caching extension for caching calls to Database#indexes (kenaniah, jeremyevans) (#1461)

* Allow Database#indexes on SQLite, MSSQL, SQLAnywhere, and DB2 to handle SQL::Identifier values (jeremyevans)

* Add pg_timestamptz extension for using timestamptz (timestamp with time zone) as the default timestamp type (jeremyevans)

* Support Sequel.date_{add,sub} :cast option for setting cast type in date_arithmetic extension (jeremyevans)

* Optimize Database#synchronize implementation on ruby 2.5+ (jeremyevans)

* Add class_table_inheritance plugin :ignore_subclass_columns option (brianphillips) (#1459)

* Make Dataset#to_xml in xml_serializer work with eager_graphed datasets (jeremyevans)

* Make Dataset#to_json in json_serializer work with eager_graphed datasets (jeremyevans)

* Cache Dataset#nullify dataset in the null_dataset extension (chanks) (#1456)

* Add datetime_parse_to_time extension, for parsing timestamp strings without offsets using DateTime.parse.to_time (jeremyevans) (#1455)

* Add WHERE NULL filter for Dataset#where calls with no existing filter, no argument, and where the virtual row block returns nil (jeremyevans)

=== 5.3.0 (2017-12-01)

* Add logger to Database instance before making first connection in bin/sequel (jeremyevans)

* Drop support for PostgreSQL <8.1 in Database#indexes (jeremyevans)

* Add synchronize_sql extension, for checking out a connection around SQL generation (KJTsanaktsidis, jeremyevans) (#1451)

* Deprecate Dataset#where calls with no existing filter, no argument, and where the virtual row block returns nil (jeremyevans) (#1454)

* Add DatasetModule#reverse for simpler use of descending orders (jeremyevans)

* Support WITH clauses in subqueries on SQLite, but not in UNION/INTERSECT/EXCEPT (jeremyevans)

* Hoist WITH clauses to INSERT statement level if INSERT subquery uses a CTE on MSSQL (jeremyevans)

* Respect indislive and ignore indcheckxmin index attributes when using Database#indexes on PostgreSQL (jeremyevans)

* Explicitly disallow use of server-side prepared statements when using Dataset#call in the jdbc/postgresql adapter (jeremyevans) (#1448)

* Support common table expressions, window functions, dropping CHECK constraints, and recognizing CURRENT_DATE defaults on MariaDB 10.2+ (jeremyevans)

* Make Database#reset_primary_key_sequence work on PostgreSQL 10+ (jeremyevans)

* Support :connect_sqls Database option for easily issuing sql commands on all new connections (jeremyevans)

* Support :extensions Database option for loading extensions when initializing, useful in connection strings (jeremyevans)

* Avoid warning if trying to rollback after a commit or rollback raises an exception in the postgres adapter (jeremyevans)

* Support Date::Infinity values in the pg_extended_date_support extension (jeremyevans)

=== 5.2.0 (2017-10-27)

* Fix type conversion for smallint unsigned and integer unsigned types on jdbc/mysql (jeremyevans) (#1443)

* Add pg_extended_date_support extension, for handling infinite and BC dates/timestamps (jeremyevans)

* Do not ignore existing @dataset instance variable when subclassing Sequel::Model (bjmllr) (#1435)

=== 5.1.0 (2017-10-01)

* Make jdbc/h2 and jdbc/hsqldb adapters respect :foreign_key_constraint_name option when adding new foreign key column (jeremyevans)

* Do not issue unnecessary query for macaddr type oid when loading the pg_inet extension (jeltz) (#1423)

* Make alter_table add_foreign_key with a column symbol reversible when using the :foreign_key_constraint_name option (jeremyevans) (#1422)

* Do not raise an error if calling Model.freeze on a frozen model (jeremyevans) (#1421)

* Make Database#copy_into in the jdbc/postgresql adapter handle multi-byte strings (ckoenig) (#1416)

* Remove deprecated Model use_after_commit_rollback class and instance methods (jeremyevans)

* Remove deprecated Model.allowed_columns method in the base model support (jeremyevans)

* Remove deprecated Model.plugin_module_defined? private method (jeremyevans)

* Remove deprecated support for Model#_before_validation private method (jeremyevans)

=== 5.0.0 (2017-09-01)

* Make bin/sequel -M option always use base 10 (jeremyevans)

* Don't use savepoints when creating indexes inside a transaction on databases that don't support transactional schema modifications (jeremyevans) (#1407)

* Support :if_not_exists option when creating indexes on PostgreSQL 9.5+ (DyegoCosta) (#1405)

* Make threaded connection pools not block while connections are being made (jeremyevans)

* SQL::Expression#clone and #dup now return self, since all expressions should be frozen value objects (jeremyevans)

* Don't create empty arrays for unused association callbacks (jeremyevans)

* Cache association method name symbols instead of recomputing them everytime (jeremyevans)

* Raise an exception if attempting to create a prepared statement using a dataset with a delayed evaluation (jeremyevans)

* Make ConnectionPool#size thread safe by using the pool mutex (jeremyevans)

* Use instance_exec instead of instance_eval when passing a block, to work with lambdas that accept no arguments (jeremyevans)

* Freeze SQL::StringAgg instances in string_agg extension (jeremyevans)

* Freeze SQL::DateAdd instances in date_arithmetic extension (jeremyevans)

* Freeze SQL::Expression.comparison_attrs (jeremyevans)

* Rename SQL::Subscript#f to #expression, keeping #f as an alias (jeremyevans)

* Require the :pool_class Database option be a class to use a custom connection pool (jeremyevans)

* Make the class_table_inheritance plugin raise an Error during update if any UPDATE query does not affect a single row (jeremyevans)

* Change most send calls to public_send unless calling private methods is expected (jeremyevans)

* Database schema and schema generator methods now return nil (jeremyevans)

* Model#validates_unique in the validation helpers plugin now defaults to only checking on new or modified values (jeremyevans)

* Deprecate Model#_before_validation (private_method), use Model#before_validation now (jeremyevans)

* Always run before/after/around validation hooks when saving, even when not validating the object (jeremyevans)

* Deprecate Model use_after_commit_rollback class and instance accessors (jeremyevans)

* Deprecate Model.allowed_columns reader (jeremyevans)

* Freeze internal constants that shouldn't be modified at runtime (jeremyevans)

* Attempt to connect to the database immediately when creating the Database instance (jeremyevans)

* Make association_pks plugin delay the setting of associated objects until the current object is saved by default (jeremyevans)

* Joined datasets used as model datasets are now automatically wrapped in a subquery (jeremyevans)

* Setting an invalid dataset for a model class now raises an exception by default (jeremyevans)

* Getting all values for newly created models now happens before calling after_create, instead of after (jeremyevans)

* Remove use of @was_new/@columns_updated instance variables when saving model objects (jeremyevans)

* Disable symbol splitting by default (jeremyevans)

* Make datasets frozen by default (jeremyevans)

* Drop support for ruby 1.8.7, minimum now is 1.9.2 (jeremyevans) 

* Remove deprecated adapters, extensions, plugins, constants, and features (jeremyevans)

=== Older

See doc/CHANGELOG.old
